package PageFactory;

import common.Common;
import config.Config;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.support.FindBy;
import org.openqa.selenium.support.PageFactory;

import java.io.IOException;

public class Add_to_cart {
    WebDriver driver;
    Config config = new Config();

    @FindBy(xpath = Common.SEARCH_BAR_ID)
    WebElement search_bar;

    @FindBy(xpath = Common.BTN_SEARCH)
    WebElement btn_search;

    @FindBy(xpath = Common.PRODUCT)
    WebElement btn_product;

    @FindBy(xpath = Common.BTN_ADD_TO_CART)
    WebElement btn_addToCart;

    @FindBy(xpath = Common.EMAIL_ID)
    WebElement email_id;

    @FindBy(xpath = Common.PASSWORD)
    WebElement password;

    @FindBy(className = Common.BTN_LOGIN)
    WebElement btn_login;

    @FindBy(xpath = Common.BTN_CHECKOUT)
    WebElement btn_checkout;

    @FindBy(xpath = Common.I_FRAME)
    WebElement iframe;

    @FindBy(xpath = Common.BTN_EDIT)
    WebElement btn_edit;

    @FindBy(xpath = Common.ENTER_CNIC)
    WebElement enter_cnic;

    @FindBy(xpath = Common.BTN_SAVE)
    WebElement btn_save;

    @FindBy(xpath = Common.ERROR_MESSAGE)
    WebElement error_message;

    public Add_to_cart(WebDriver driver) throws IOException {
        this.driver = driver;
        PageFactory.initElements(driver, this);
    }
    public void searchProduct() {
        search_bar.sendKeys(config.getSearchProduct());
    }
    public void searchButton() {
        btn_search.click();
    }
    public void product() {
        btn_product.click();
    }
    public void addToCart() {
        btn_addToCart.click();
    }
    public void email_id() {
        driver.switchTo().frame(iframe);
        email_id.sendKeys(config.getEmail());
    }
    public void password() {
        password.sendKeys(config.getPassword());
    }
    public void login() {
        btn_login.click();
    }
    public void checkout() {
        btn_checkout.click();
    }
    public void editButton() {
        btn_edit.click();
        enter_cnic.sendKeys(config.getInvalidCNIC());
        btn_save.click();
    }
    public void errorMessage(){
        error_message.getText();
    }
}
