package StepDefinitions;

import PageFactory.Add_to_cart;
import common.Common;
import config.Config;
import driver.Driver;
import io.cucumber.java.en.And;
import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.openqa.selenium.WebDriver;

import java.io.IOException;

public class Steps_AddToCart {
    WebDriver driver;
    Config config = new Config();
    Add_to_cart cart;

    public Steps_AddToCart() throws IOException {
    }

    @Given("user is navigated to daraz page")
    public void userIsNavigatedToDarazPage() throws IOException {
        this.driver = Driver.chrome();
        driver.navigate().to(config.getBaseUrl());
        cart = new Add_to_cart(driver);
    }

    @And("user searches a product and clicks on it, Add to cart button appears")
    public void userSearchesAProductAndClicksOnItAddToCartButtonAppears() throws InterruptedException {
        cart.searchProduct();
        Thread.sleep(Common.TIME_IN_SECONDS);
        cart.searchButton();
        Thread.sleep(Common.TIME_IN_SECONDS);
        cart.product();
        Assert.assertTrue(driver.getPageSource().contains(Common.TITLE));
    }

    @When("user clicks on Add to cart, user navigated to login window")
    public void userClicksOnAddToCartUserNavigatedToLoginWindow() throws InterruptedException {
        cart.addToCart();
        Thread.sleep(Common.TIME_IN_SECONDS);
        Assert.assertTrue(driver.getPageSource().contains(Common.TITLE2));
    }

    @And("user sign in with valid credentials")
    public void userSignInWithValidCredentials() throws InterruptedException {
        cart.email_id();
        cart.password();
        Thread.sleep(Common.TIME_IN_SECONDS);
        cart.login();
        Thread.sleep(Common.TIME_IN_SECONDS);
    }

    @Then("user is navigated to added cart window and clicks on checkout")
    public void userIsNavigatedToAddedCartWindow() throws InterruptedException {
        Thread.sleep(Common.TIME_IN_SECONDS);
        cart.checkout();
        Thread.sleep(Common.TIME_IN_SECONDS);
    }

    @And("user should see Order summary")
    public void userShouldSeeProceedToPayButton() {
        Assert.assertTrue(driver.getPageSource().contains(Common.TITLE4));
    }

    @When("user enters invalid credential")
    public void userEntersInvalidCredential() {
        cart.editButton();
    }

    @Then("user should see error message")
    public void userShouldSeeErrorMessage() {
        cart.errorMessage();
        driver.close();
    }
}
